<template>
<div>
  <h1>افزودن مخاطب</h1>
  <form action="#" @submit.prevent="edit ? updateContact(contact.id) : createContact()">
    <div class="form-group">
      <label>نام</label>
      <input v-model="contact.name" type="text" name="name" class="form-control">
    </div>
    <div class="form-group">
      <label>ایمیل</label>
      <input v-model="contact.email" type="text" name="email" class="form-control">
    </div>
    <div class="form-group">
      <label>تلفن</label>
      <input v-model="contact.phone" type="text" name="phone" class="form-control">
    </div>
    <div class="form-group">
      <button v-show="!edit" type="submit" class="btn btn-primary">مخاطب جدید</button>
      <button v-show="edit" type="submit" class="btn btn-primary">ویرایش مخاطب</button>
    </div>
  </form>
  <h1>مخاطبین</h1>
  <ul class="list-group">
    <li class="list-group-item" v-for="contact in list">
    <strong>{{contact.name}}</strong> {{contact.email}} {{contact.phone}} 
    <button @click="showContact(contact.id)" class="btn btn-info btn-xs">ویرایش</button>
    <button @click="deleteContact(contact.id)" class="btn btn-danger btn-xs">حذف</button>
    </li>
  </ul>
</div>
</template>

<script lang="ts">
export default{
  data: function(){
    return{
      edit:false,
      list:[],
      contact:{
        id:'',
        name:'',
        email:'',
        phone:''
      }
    }
  },
  mounted: function(){
    console.log('contacts component loaded...');
    this.fetchContactList();
  },
  methods:{
    fetchContactList:function(){
      console.log('fetching contacts...');
      axios.get('api/contacts')
      .then((response)=>{
        console.log(response.data);
        this.list = response.data;
      }).catch((error) => {
        console.log(error);
      });
    },
    createContact: function(){
      console.log('creating contact...');
      let self = this;
      let params = Object.assign({}, self.contact);
      axios.post('api/contact/store', params)
      .then(function(){
        self.contact.name = '';
        self.contact.email = '';
        self.contact.phone = '';
        self.edit = false;
        self.fetchContactList();
      })
      .catch(function(error){
        console.log(error);
      });
    },
    showContact:function(id){
      let self = this;
      axios.get('api/contact/'+id)
      .then(function(response){
        self.contact.id = response.data.id;
        self.contact.name = response.data.name;
        self.contact.email = response.data.email;
        self.contact.phone = response.data.phone;
      })
      self.edit = true;
    },
    updateContact: function(id){
      console.log('updating contact '+id+'...');
      let self = this;
      let params = Object.assign({}, self.contact);
      axios.patch('api/contact/'+id, params)
      .then(function(){
        self.contact.name = '';
        self.contact.email = '';
        self.contact.phone = '';
        self.edit = false;
        self.fetchContactList();
      })
      .catch(function(error){
        console.log(error);
      });
    },
    // TODO: after deleting contact the page should be refresh to see the changes and this is not good
    deleteContact: function(id){
      axios.delete('api/contact/'+id)
      .then(function(response){
        self.fetchContactList();
      })
      .catch(function(error){
        console.log(error);
      });
    }
  }
}
</script>